TITLE    'TastInt9.ASM, Endlosschleife durch Funktions-Tastendruck abbrechen'
; Nach Tastendruck Ausgabe einer Meldung. Das Programm ist so ausgelegt, da
; auf mehrere Funktionstasten geprft werden knnte, hier sind jedoch nur F4
; und F6 implementiert
TastInt   EQU      09h       ; Tastatur-Interrupt fr Abbruch
Attribut  EQU      0C7h

SegBIOS   SEGMENT AT 40h
          ORG    1Ah
BufHead   DW     ?           ; Zeiger auf am lngsten im Puffer befindliches
                             ; Zeichen
BufTail   DW     ?           ; Zeiger auf nchste freie Position im Puffer
Buffer    DW     16 DUP (?)  ; Buffer-Bereich
SegBIOS   ENDS

CodeSeg   SEGMENT  PARA PUBLIC 'Code'
          ASSUME   CS:CodeSeg,SS:CodeSeg
          ASSUME   DS:CodeSeg,ES:SegBIOS
          ORG      100h
Begin:    JMP    Start
;
ScanCode  DB     2          ; Anzahl zu prfender Scancodes
          DB     3Eh,40h    ; 3Eh = F4-Taste, 40h = F6-Taste
          DB     0          ; mindestens ein Byte hinter letztem Scan-Code
                            ; mu 00h enthalten (ntig fr Prfung in IRPruef)
Flag      DB     0          ; 0 = Programm fortsetzen, Scan-Code = Hot-Key
                            ; wurde gedrckt
BellText  DB     7          ; Piepston
TastAdr   DD     0          ; Vektor des Tastaturinterrupts: Offset, Segment
InDosAdr  DD     0          ; Adresse des In-DOS-Flags (Offset, Segment)
MeldText  DB     ' Abbruch '
;
Start:   MOV    AX,3        ; Bildschirmmodus auf Text 80x25, Bildschirm
         INT    10h         ; dabei lschen
         MOV    Flag,0      ; Flag auf "Schleife fortsetzen" setzen
         MOV    AH,34h      ; undokumentierte DOS-Funktion:
         INT    21h         ; Adresse des  "In-DOS-Flag" holen
         MOV    WORD PTR InDosAdr+2,ES
         MOV    WORD PTR InDosAdr,BX ; Adresse abgespeichert
         MOV    AH,35h      ; Interrupt-Vektor erfragen
         MOV    AL,TastInt  ; zugehrige Interrupt-Nummer
         INT    21h         ; jetzt alte Interrupt-Adresse in ES:BX
         MOV    WORD PTR TastAdr+2,ES
         MOV    WORD PTR TastAdr,BX  ; jetzt gesichert in Reihenfolge IP, CS
         LEA    DX,IntRout  ; DX erhlt Offset der Interrupt-Routine
         MOV    AH,25h      ; Interrupt-Vektor belegen
         MOV    AL,TastInt  ; zugehrige Interrupt-Nummer
         INT    21h
;
Alpha:   MOV      CX,26     ; 26 Grobuchstaben gibt es
         MOV      AH,2      ; Bildschirmausgabe
         MOV      DL,'A'    ; erstes auszugebendes Zeichen
Loopi:   INT      21h       ; DOS-Funktionsaufruf
         CMP      Flag,0    ; Schleife fortsetzen ?
         JNE      Ende      ; nein
         INC      DL        ; ja: nchster Grobuchstabe im Alphabet
;         PUSH     CX    ; diese 4 Zeilen wirksam oder unwirksam machen!
;         XOR      CX,CX ; Zeitschleife zum Verzgern der zeichenweisen
;         LOOP     $     ; Ausgabe, Zhler von 65536 abwrts
;         POP      CX    ;
         MOV      AH,2
         LOOP     Loopi     ; Schleife 26 mal
         JMP      Alpha     ; Endlosschleife
;
Ende:    MOV    AH,0        ; BIOS-Funktion Tastatur - Zeichen aus Tastatur-
         INT    16h         ; Puffer lesen, damit das Zeichen, das dem
                            ; Abbruch-Hotkey entspricht, nicht nachher
                            ; erscheint, etwa im DOS

         MOV    AX,0C00h    ; Tastaturpuffer lschen
         INT    21h         ; damit Tastendruck fr Abbruch wirksam wird

         PUSH   CS          ; hier knnte noch der in Flag zurckgegebene
         POP    DS          ; Scan-Code identifiziert werden und je nach
                            ; gedrckter Funktionstaste reagiert werden
         MOV    DL,BellText ; Piepston
         MOV    AH,2        ; ausgeben
         INT    21h
         CALL   CGAAusg     ; Hot-Key-Aktivitt (hier: Meldung einblenden)
         MOV    AH,4Ch      ; EXIT (Programm beenden)
         INT    21h
;
CGAAusg: XOR    BL,BL       ; Routine, die direkt ins Video-RAM schreibt
         MOV    AH,15       ; Bildschirmmodus feststellen
         INT    10h         ; BIOS-Video-Interrupt
         CMP    AL,3        ; Bildschirmmodus 3 (Textmodus 80x25, Farbe) ?
         JE     CGAA0       ; ja
         MOV    AX,3        ; nein: Bildschirmmodus auf 3 setzen
         INT    10h
CGAA0:   MOV    CL,4
         SHL    BX,CL       ; 0 bis 3 mal 4096 (aktuelle Bildschirmseite)
         MOV    AX,0B800h   ; CGA-Videospeicher Anfang
         ADD    AX,BX       ; Anfang der aktuellen Seite
         ADD    AX,12*160/16 ; zwlfte Zeile, /16 weil Segmentdresse
         PUSH   AX
         POP    ES
         MOV    CX,9        ; Lnge der Abbruch-Meldung
         LEA    SI,MeldText
         MOV    DI,36*2     ; Spalte 36 fr erste Zeichenausgabe
CGAA1:   MOV    AL,[SI]
         MOV    BYTE PTR ES:[DI],AL
         INC    SI
         INC    DI
         MOV    BYTE PTR ES:[DI],Attribut
         INC    DI
         LOOP   CGAA1
         RET
;
IntRout  PROC   FAR         ; Interrupt-Routine fr INT 9
         PUSH   AX
         PUSH   BX
         PUSH   CX
         PUSH   DX
         PUSH   SI
         PUSH   DI
         PUSH   BP
         PUSH   ES
         PUSH   DS
         PUSHF             ; "Chaining" zur alten Interrupt-Routine
         CLI               ; zunchst normale Tastatur-Interrupt-Routine
         CALL   CS:TastAdr ; ausfhren, statt INT-Befehl wird PUSHF + CALL FAR
                           ; ausgefhrt, damit nicht beim nchsten Tastendruck
                           ; wieder IntRout aktiviert wird

         PUSH   CS
         POP    DS           ; Adressierbarkeit im Programm sicherstellen
         LES    BX,InDosAdr  ; ES:BX zeigt jetzt auf In-DOS-Flag
         CMP    BYTE PTR ES:[BX],0 ; das Byte dort sollte 00h sein
         JNE    IREnd        ; wenn nicht: Interrupt-Routine verlassen, weil
                             ; DOS gerade aktiv ist
         MOV    AX,SegBIOS
         MOV    ES,AX        ; Segmentadresse
         MOV    SI,ES:BufTail ; Adresse des letzten Zeichens im Puffer
         SUB    SI,2         ; Zeiger auf vorhergehendes Wort im Puffer
         CMP    BYTE PTR ES:[SI],0 ; Sondertaste ?
         JNE    IREnd        ; nein: Taste ungltig
         MOV    AL,BYTE PTR ES:[SI+1] ; ja: Scancode aus Tastaturpuffer holen
         LEA    DI,ScanCode  ; Byte vor erstem zu prfenden Scan-Code
         XOR    CX,CX
         MOV    CL,ScanCode  ; Anzahl zu prfender Scan-Codes
         INC    CL           ; damit Endbyte (mit 00h) noch mitgeprft wird
IRPruef: INC    DI           ; nchster zu prfender Scan-Code
         CMP    AL,[DI]      ; richtige Funktionstaste ?
         LOOPNE IRPruef      ; nein: Taste ungltig
         MOV    AL,[DI]      ; ja: gltiger Scan-Code oder 00h
         CMP    BYTE PTR [DI],00h ; 00h ?
         JE     IREnd        ; ja
         MOV    Flag,AL      ; nein: Scan-Code als Signal "Schleife beenden"

         MOV    AH,25h      ; Interrupt-Vektor wieder auf INT 9 legen
         CLI                ; Interrupts sperren
         MOV    AL,TastInt  ; zugehriger Interrupt-Vektor
         LDS    DX,TastAdr  ; DS:DX enthlt FAR-Adresse der alten INT-9-Routine
         INT    21h         ; jetzt Interruptroutine wieder unwirksam
         STI                ; Interrupts wieder freigeben
                            ; Anmerkung: diese Routine knnte auch in der
                            ; Routine Ende nach dem Lesen aus dem Tastatur-
                            ; puffer stehen
IREnd:   POP    DS
         POP    ES
         POP    BP
         POP    DI
         POP    SI
         POP    DX
         POP    CX
         POP    BX
         POP    AX
         IRET                ; zurck ins unterbrochene Programm
IntRout  ENDP
CodeSeg  ENDS
         END    Begin
