#ifndef __KEYSCAN_H
#define __KEYSCAN_H

#define SCAN_CTRL_BREAK	0x00
#define SCAN_ESCAPE	0x01
#define SCAN_ALT_ESCAPE	0x01
#define SCAN_1	0x02
#define SCAN_2	0x03
#define SCAN_3	0x04
#define SCAN_4	0x05
#define SCAN_5	0x06
#define SCAN_6	0x07
#define SCAN_7	0x08
#define SCAN_8	0x09
#define SCAN_9	0x0a
#define SCAN_0	0x0b
#define SCAN_BACKSPACE	0x0E
#define SCAN_CTRL_BACKSPACE	0x0E
#define SCAN_TAB	0x0F
#define SCAN_BACKTAB	0x0F
#define SCAN_ALT_Q	0x10
#define SCAN_ALT_W	0x11
#define SCAN_ALT_E	0x12
#define SCAN_ALT_R	0x13
#define SCAN_ALT_T	0x14
#define SCAN_ALT_Y	0x15
#define SCAN_ALT_U	0x16
#define SCAN_ALT_I	0x17
#define SCAN_ALT_O	0x18
#define SCAN_ALT_P	0x19
#define SCAN_ENTER	0x1C
#define SCAN_ALT_A	0x1E
#define SCAN_ALT_S	0x1F
#define SCAN_ALT_D	0x20
#define SCAN_ALT_F	0x21
#define SCAN_ALT_G	0x22
#define SCAN_ALT_H	0x23
#define SCAN_ALT_J	0x24
#define SCAN_ALT_K	0x25
#define SCAN_ALT_L	0x26
#define SCAN_ALT_Z	0x2C
#define SCAN_ALT_X	0x2D
#define SCAN_CTRL_C	0x2E
#define SCAN_ALT_C	0x2E
#define SCAN_ALT_V	0x2F
#define SCAN_ALT_B	0x30
#define SCAN_ALT_N	0x31
#define SCAN_ALT_M	0x32
#define SCAN_ALT_PERIOD	0x34
#define SCAN_GRAY_MULTIPLY	0x37
#define SCAN_ALT_GRAY_MULTIPLY	0x37
#define SCAN_SPACE	0x39
#define SCAN_ALT_SPACE	0x39
#define SCAN_F1	0x3B
#define SCAN_F2	0x3C
#define SCAN_F3	0x3D
#define SCAN_F4	0x3E
#define SCAN_F5	0x3F
#define SCAN_F6	0x40
#define SCAN_F7	0x41
#define SCAN_F8	0x42
#define SCAN_F9	0x43
#define SCAN_F10	0x44
#define SCAN_GRAY_HOME	0x47
#define SCAN_WHITE_HOME	0x47
#define SCAN_GRAY_UP_ARROW	0x48
#define SCAN_WHITE_UP_ARROW	0x48
#define SCAN_GRAY_PGUP	0x49
#define SCAN_WHITE_PGUP	0x49
#define SCAN_GRAY_MINUS	0x4A
#define SCAN_ALT_GRAY_MINUS	0x4A
#define SCAN_GRAY_LEFT_ARROW	0x4B
#define SCAN_WHITE_LEFT_ARROW	0x4B
#define SCAN_WHITE_CENTER	0x4C
#define SCAN_GRAY_RIGHT_ARROW	0x4D
#define SCAN_WHITE_RIGHT_ARROW	0x4D
#define SCAN_GRAY_PLUS	0x4E
#define SCAN_ALT_GRAY_PLUS	0x4E
#define SCAN_GRAY_END	0x4F
#define SCAN_WHITE_END	0x4F
#define SCAN_GRAY_DOWN_ARROW	0x50
#define SCAN_WHITE_DOWN_ARROW	0x50
#define SCAN_GRAY_PGDN	0x51
#define SCAN_WHITE_PGDN	0x51
#define SCAN_GRAY_INSERT	0x52
#define SCAN_WHITE_INSERT	0x52
#define SCAN_GRAY_DELETE	0x53
#define SCAN_WHITE_DELETE	0x53
#define SCAN_SHIFT_F1	0x54
#define SCAN_SHIFT_F2	0x55
#define SCAN_SHIFT_F3	0x56
#define SCAN_SHIFT_F4	0x57
#define SCAN_SHIFT_F5	0x58
#define SCAN_SHIFT_F6	0x59
#define SCAN_SHIFT_F7	0x5A
#define SCAN_SHIFT_F8	0x5B
#define SCAN_SHIFT_F9	0x5C
#define SCAN_SHIFT_F10	0x5D
#define SCAN_CTRL_F1	0x5E
#define SCAN_CTRL_F2	0x5F
#define SCAN_CTRL_F3	0x60
#define SCAN_CTRL_F4	0x61
#define SCAN_CTRL_F5	0x62
#define SCAN_CTRL_F6	0x63
#define SCAN_CTRL_F7	0x64
#define SCAN_CTRL_F8	0x65
#define SCAN_CTRL_F9	0x66
#define SCAN_CTRL_F10	0x67
#define SCAN_ALT_F1	0x68
#define SCAN_ALT_F2	0x69
#define SCAN_ALT_F3	0x6A
#define SCAN_ALT_F4	0x6B
#define SCAN_ALT_F5	0x6C
#define SCAN_ALT_F6	0x6D
#define SCAN_ALT_F7	0x6E
#define SCAN_ALT_F8	0x6F
#define SCAN_ALT_F9	0x70
#define SCAN_ALT_F10	0x71
#define SCAN_CTRL_GRAY_LEFT_ARROW	0x73
#define SCAN_CTRL_WHITE_LEFT_ARROW	0x73
#define SCAN_CTRL_GRAY_RIGHT_ARROW	0x74
#define SCAN_CTRL_WHITE_RIGHT_ARROW	0x74
#define SCAN_CTRL_GRAY_END	0x75
#define SCAN_CTRL_WHITE_END	0x75
#define SCAN_CTRL_GRAY_PGDN	0x76
#define SCAN_CTRL_WHITE_PGDN	0x76
#define SCAN_CTRL_GRAY_HOME	0x77
#define SCAN_CTRL_WHITE_HOME	0x77
#define SCAN_ALT_1	0x78
#define SCAN_ALT_2	0x79
#define SCAN_ALT_3	0x7A
#define SCAN_ALT_4	0x7B
#define SCAN_ALT_5	0x7C
#define SCAN_ALT_6	0x7D
#define SCAN_ALT_7	0x7E
#define SCAN_ALT_8	0x7F
#define SCAN_ALT_9	0x80
#define SCAN_ALT_0	0x81
#define SCAN_ALT_WHITE_MINUS	0x82
#define SCAN_ALT_WHITE_PLUS	0x83
#define SCAN_CTRL_GRAY_PGUP	0x84
#define SCAN_CTRL_WHITE_PGUP	0x84
#define SCAN_F11	0x85
#define SCAN_F12	0x86
#define SCAN_SHIFT_F11	0x87
#define SCAN_SHIFT_F12	0x88
#define SCAN_CTRL_F11	0x89
#define SCAN_CTRL_F12	0x8A
#define SCAN_ALT_F11	0x8B
#define SCAN_ALT_F12	0x8C
#define SCAN_CTRL_GRAY_UP_ARROW	0x8D
#define SCAN_CTRL_WHITE_UP_ARROW	0x8D
#define SCAN_CTRL_GRAY_MINUS	0x8E
#define SCAN_CTRL_WHITE_CENTER	0x8F
#define SCAN_CTRL_GRAY_PLUS	0x90
#define SCAN_CTRL_GRAY_DOWN_ARROW	0x91
#define SCAN_CTRL_WHITE_DOWN_ARROW	0x91
#define SCAN_CTRL_GRAY_INSERT	0x92
#define SCAN_CTRL_WHITE_INSERT	0x92
#define SCAN_CTRL_GRAY_DELETE	0x93
#define SCAN_CTRL_WHITE_DELETE	0x93
#define SCAN_CTRL_TAB	0x94
#define SCAN_CTRL_GRAY_DIVIDE	0x95
#define SCAN_CTRL_GRAY_MULTIPLY	0x96
#define SCAN_ALT_GRAY_HOME	0x97
#define SCAN_ALT_GRAY_UP_ARROW	0x98
#define SCAN_ALT_GRAY_PGUP	0x99
#define SCAN_ALT_GRAY_LEFT_ARROW	0x9B
#define SCAN_ALT_GRAY_RIGHT_ARROW	0x9D
#define SCAN_ALT_GRAY_END	0x9F
#define SCAN_ALT_GRAY_DOWN_ARROW	0xA0
#define SCAN_ALT_GRAY_PGDN	0xA1
#define SCAN_ALT_GRAY_INSERT	0xA2
#define SCAN_ALT_GRAY_DELETE	0xA3
#define SCAN_ALT_GRAY_DIVIDE	0xA4
#define SCAN_GRAY_ENTER	0xE0
#define SCAN_GRAY_DIVIDE	0xE0

#endif //__KEYSCAN_H

